import os
import config
import pandas as pd
from db_connet import *
from datetime import datetime, timedelta, timezone

__directory__ = os.path.dirname(os.path.abspath(__file__))
__LogFileName__ = datetime.today().strftime("%Y%m%d")+'.txt'

def now():
    tz = timezone(timedelta(hours=+8))
    return datetime.now(tz).strftime("%Y-%m-%d %H:%M:%S")

def today():
    tz = timezone(timedelta(hours=+8))
    return datetime.now(tz).strftime("%Y-%m-%d")

def logTxt(msg):
    filename = f"{__directory__+'/logs/'+__LogFileName__}"
    f = open(filename, "a")
    f.write("{0} -- {1}\n".format(now(), msg))
    f.close()

def datelist(beginDate, endDate):
    date = [datetime.strftime(x,'%Y-%m-%d') for x in list(pd.date_range(start = beginDate, end = endDate))]
    return date

def yesterday():
    tz = timezone(timedelta(hours=+8))
    current_time = datetime.now(tz)
    yesterday = current_time - timedelta(days=1)
    return yesterday.strftime("%Y-%m-%d")


# 將會員中心id寫入data-lake(POS)
# 預設：昨天日期
def clear_member(start=yesterday(),end=yesterday()):
    days = datelist(start,end)
    logTxt('將會員中心id寫入data-lake')
    for date in days:
        sql = f"""
            SELECT u.id as userId,p.firm_service_id,p.order_code,p.created_at 
            FROM `purchases` p
            LEFT JOIN user_relations ur on p.user_relation_id = ur.id
            LEFT JOIN users u on ur.user_id = u.id
            WHERE p.order_code LIKE 'P%' 
            and p.created_at like '{date}%';
        """
        logTxt(sql)
        pos_member_purchase = select_db(sql,'member')

        for i in pos_member_purchase:
            sql = f"""
                UPDATE `omo_order_list` SET userId = '{i['userId']}'
                WHERE ordernumber = '{i['order_code']}' 
            """
            update_db(sql,'lake')
            logTxt(sql)




# ==== 執行區塊 ====
print(clear_member())
    

# ==== 暫放區塊 ====
# clear_member('2023-10-25','2023-10-25')

